SELECT
    an.numero as MATRIZ
  , AN.DTNASCIMENTO AS NASCIMENTO
  , (select sp.grausangue from sp_calculagrausangue (an.cdanimal) sp) as grau_sangue_matriz -- Grau de sangue
  , cat.nome as categoria
  , ultpar.data as data_ultimo_parto

  , ultia.data as data_ult_ia
  , COALESCE(TOU.NUMERO, AR.DESCRICAO) AS ult_reprodutor
  , pes.nome as ult_inseminador
  , ultiatf.descricao as ult_protocolo_utilizado

  , penultia.data as data_penult_ia
  , COALESCE(penultTOU.NUMERO, penultAR.DESCRICAO) AS penult_reprodutor
  , penultpes.nome as penultult_inseminador
  , penultiatf.descricao as penult_protocolo_utilizado

  , antpenultia.data as data_antpenult_ia
  , COALESCE(antpenultTOU.NUMERO, antpenultAR.DESCRICAO) AS antpenult_reprodutor
  , antpenultpes.nome as antpenultult_inseminador
  , antpenultiatf.descricao as antpenult_protocolo_utilizado
from
    animal an
    left join reproducao ultpar on ultpar.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc)
    LEFT JOIN SETOR S ON S.CDSETOR = AN.CDSETOR
    join categoria cat on cat.cdcategoria = an.cdcategoria

    left join reproducao ultia on ultia.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) and
                re.data > coalesce(ultpar.data, '1900-01-01') order by re.data desc)
    left join protocoloiatf ultiatf on ultiatf.cdprotocoloiatf = ultia.cdprotocoloiatf
    LEFT JOIN ANIMAL TOU ON TOU.CDANIMAL = ultia.CDREPRODUTOR
    LEFT JOIN RACA AR ON AR.CDRACA = ultia.CDRACA
    left join pessoa pes on pes.cdpessoa = ultia.cdpessoa

    left join reproducao penultia on penultia.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ultia.cdanimal and re.cdtiporeproducao in (1,2,3) and
                re.data < ultia.data order by re.data desc)
    left join protocoloiatf penultiatf on penultiatf.cdprotocoloiatf = penultia.cdprotocoloiatf
    LEFT JOIN ANIMAL penultTOU ON penultTOU.CDANIMAL = penultia.CDREPRODUTOR
    LEFT JOIN RACA penultAR ON penultAR.CDRACA = penultia.CDRACA
    left join pessoa penultpes on penultpes.cdpessoa = penultia.cdpessoa

    left join reproducao antpenultia on antpenultia.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = penultia.cdanimal and re.cdtiporeproducao in (1,2,3) and
                re.data < penultia.data order by re.data desc)
    left join protocoloiatf antpenultiatf on antpenultiatf.cdprotocoloiatf = antpenultia.cdprotocoloiatf
    LEFT JOIN ANIMAL antpenultTOU ON antpenultTOU.CDANIMAL = antpenultia.CDREPRODUTOR
    LEFT JOIN RACA antpenultAR ON antpenultAR.CDRACA = antpenultia.CDRACA
    left join pessoa antpenultpes on antpenultpes.cdpessoa = antpenultia.cdpessoa

WHERE
  an.animalrebanho = 1
  and an.cdcategoria in (6,7)
  and an.dtbaixa is null
